{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O-,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y-,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}

{
 a native Win32 client for the Palantir system

 Copyright 2001-2006 David Santinoli
 Released under the GNU General Public License.
 See file COPYING.txt for details.

 TODO: upon gaining control, why do we transmit device updates for devices
  whose status is unchanged wrt the server?
  Upon connection, hide xyz values if there are no xyz devices
  Upon connection, disable device checkbox (sometimes it remains enabled)
  if there are no sensors.

 v2.4 (22/9/2006)
 - Audio to server is now working. The MM_WIM_DATA event was not being sent
   to the handler inside TACMWaveIn. Resolved by declaring the message handler
   inside viewForm.
 - Removed TF from demo sites.
 - Clicking on the "Servers" menu header no longer triggers a connection
   (have to click on a menu _item_ instead).

 v2.3.5 (26/10/2005)
 - Localization via resources
 - Hide 'xyz readings' in simplified version

 v2.3.4 (10/4/2005)
 - added label to zoom slider
 - disable/reenable onChange handler for scrollbars in Devices.updatePos
   to prevent position setup by X-Sensor-Change from generating an update event.
   (What about TTrackBars?)

 v2.3.3 (3/7/2004)
 - Added site Tieffesistemi.com:11120
 - get audio availability and port from "X-Audio-Port: " header
   (the former "X-Audio: " is no longer sent by the server)
 - check against "X-Protocol-Version: " and warn user if client is out of date

 v2.3.2 (31/3/2004)
 - xvalLabel and yvalLabel are now properly repositioned upon window resizing.

 v2.3.1 (4/2/2004)
 - x, y, z sliders have now their own "Visual" definition in palantir.conf
   (new types 'x', 'y', 'z'; the client however remaps them to 's' just
   after detection).
 - labels displaying pan/tilt/zoom controls' position can be shown or hidden
   via a menu item ("XYZ values").
 - "zoom" label ripped off.  "W" and "T" labels are now only shown if the
   control's name is "Zoom".
 - after gaining control, disconnecting, then reconnecting, the special sliders
   were not properly positioned (csLButtonDown bug). Fixed.

 v2.3 (9/8/2003)
 - if a pclient.ini file is found in the current directory, it is used
   to initialize the client.  Sample layout follows:

   [global]
   autoconnect= 1 | 0
   defaultserver= URL

   [serverlist]
   server0= URL[,DESCR]
   server1= URL[,DESCR]
   ...

   The maximum number of servers in the list (10) is currently hardcoded.

 v2.2.1 (8/1/2003)
 - default server Edit box is now left blank at startup, and connection
   is not possible unless its content is non-empty.

 v2.2 (7/8/2002)
 - 'val' arguments in any 'name=val' couple received from the server
   are %-decoded (though the server actually encodes only device names
   and hints).
 - Device form Y coordinate calculation now prevents the bottom of the
   form from falling off screen.
 - Audio selector is only enabled if audio is available at the server
   (header 'X-Audio: 1' must be received)
 - Control button is only enabled if there are controllable devices
   and/or the audio channel is available.
 - "Server-snapshot" mode (too many streaming clients) is supported
   (look for header 'X-Snapshot: 1')
 - New "Servers" menu allows quick connection to known servers.

 v2.1 (22/7/2002)
 - Got rid of ACM components. Placed corresponding code in unit acmwave.
 - Audio device is profiled at startup; if setup is suboptimal, diagnostics
   are presented to the user and features are restricted (e.g. client is
   enabled to listen but not to talk).
 - If a device definition's imax exceeds 32767, an offset of 32768 is
   subtracted to get the actual Position to set controls to
   (since slider/track/progress controls are bound to have min>=-32768
   and max <=32767).
 - Version number displayed at startup.
 - Critical characters in user text are %-encoded before transmission
   (currently done for ';' and '%').
 - Control button is disabled when client is disconnected.
 - The device parser now correctly looks for the 'hint=' keyword in messages
   from the server, instead of the obsoleted 'text='. The hint is now placed
   both over the device's short name and over its current value.
 v2.0.2a (15/7/2002)
 - Complete server URL to be displayed in the devices' form caption is now
   retrieved from an ad-hoc var, serverURL, instead of srvEdit.text (which
   caused the message string to appear in the caption in place of the
   server name when Message mode was selected. Thanks PV.)
 v2.0.1 (12/7/2002)
 - audio TCP port is now correctly computed from the URL
}

unit palancli;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jpeg, ExtCtrls, StdCtrls, Buttons, WSocket,
  mmsystem, ComCtrls, Menus, sense, msacm, IniFiles, acmwave;


type

  TNameVal = record
     name: String;
     value: String;
     end;

  TLogLevel = (LOG_NULL, LOG_INFO, LOG_CRIT, LOG_FAIL);
  TLogger = class(TObject)
    private
       currLevel: TLogLevel;
       target: TLabel;
       failure: String;
    public
       constructor Create(lbl: TLabel);
       procedure log(s: String; level: TLogLevel);
       procedure Clean;
       function isFailure: boolean;
    end;

  TviewForm = class(TForm)
    SrvEdit: TEdit;
    Panel1: TPanel;
    Image1: TImage;
    streamBtn: TButton;
    WSock1: TWSocket;
    ctlLabel: TLabel;
    audiosock: TWSocket;
    yScrollBar: TScrollBar;
    xScrollBar: TScrollBar;
    zScrollBar: TScrollBar;
    ctlButton: TButton;
    zoomWLabel: TLabel;
    zoomTLabel: TLabel;
    zvalLabel: TLabel;
    ctlTimer: TTimer;
    videoBox: TCheckBox;
    ackTimer: TTimer;
    audioBox: TCheckBox;
    sensorBox: TCheckBox;
    chnLabel: TLabel;
    MainMenu1: TMainMenu;
    ImageMenu: TMenuItem;
    menu_stretch: TMenuItem;
    Panel2: TPanel;
    menu_msg: TMenuItem;
    menu_fr: TMenuItem;
    Display1: TMenuItem;
    BottomPanel: TPanel;
    SrvLabel: TLabel;
    ServerMenu: TMenuItem;
    xvalLabel: TLabel;
    yvalLabel: TLabel;
    menu_lbl: TMenuItem;
    zoomLabel: TLabel;

    procedure setImageSize;
    procedure ShowImage(P: PChar);
    procedure addParam(var s: String; par: String);
    procedure gainControl(t: integer);
    procedure loseControl;
    function BuildParamString: String;
    procedure adjustFormHeight;
    procedure audioStart;
    procedure updateGauges(s: PChar);
    procedure FormCreate(Sender: TObject);
    procedure streamBtnClick(Sender: TObject);
    procedure WSock1SessionConnected(Sender: TObject; Error: Word);
    procedure WSock1SessionClosed(Sender: TObject; Error: Word);
    procedure WSock1DataAvailable(Sender: TObject; Error: Word);
    procedure audio(Sender: TObject);
    procedure audiosockSessionConnected(Sender: TObject; Error: Word);
    procedure audiosockSessionClosed(Sender: TObject; Error: Word);
    procedure audiosockDataAvailable(Sender: TObject; Error: Word);
    procedure ACMWaveInData(data: Pointer; size: Integer);
    procedure sensorBtnClick(Sender: TObject);
    procedure ctlButtonClick(Sender: TObject);
    procedure ctlTimerTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ackTimerTimer(Sender: TObject);
    procedure videoBoxClick(Sender: TObject);
    procedure menu_stretchClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure resizeAll(imgWidth: integer; imgHeight: integer);
    procedure menu_msgClick(Sender: TObject);
    procedure SrvEditKeyPress(Sender: TObject; var Key: Char);
    procedure sendmsg(s: String);
    procedure menu_frClick(Sender: TObject);
    procedure appMsgHandler(var Msg: TMsg; var handled: boolean);
    procedure WSock1DnsLookupDone(Sender: TObject; Error: Word);
    procedure serverMenuClick(Sender: TObject);
    procedure Connect;
    procedure Disconnect;
    procedure menu_lblClick(Sender: TObject);
  private
    { Private declarations }
    sensorsFirstPopUp: boolean;
    Logger: TLogger;
    cachedServer: String;
    serverURL: String;
    cachedMessage: String;
    TCPPort: integer;
    TCPAudioPort: integer;
    ServerHasAudio: boolean;
    ACMWaveOut1: TACMWaveOut;
    ACMWaveIn1: TACMWaveIn;
    audioInputEnabled, audioOutputEnabled: boolean;
    AppOldMsgHandler: TMessageEvent;
    procedure WaveInCallback (var msg:TMessage); message MM_WIM_DATA;
    procedure WaveOutCallback(var msg:TMessage); message MM_WOM_DONE;
  public
    { Public declarations }
  end;


  THackStream = class(TMemoryStream);
  THttpPhase = (firstheader, headers, frameinfo, expectframeinfo, framebody,
     flush);
  TAudioPhase = (AUD_MUTE, AUD_ASKING, AUD_PENDING, AUD_TALKING, AUD_MUTING);
  TCtlStatus = (CTL_DEQUEUED, CTL_ASKING, CTL_PENDING, CTL_CURRENT);
  TConnStatus = (CONN_UNCONNECTED, CONN_CONNECTING, CONN_CURRENT);
  TWidgetSet = record
     wc: TWinControl;
     l1: TLabel;
     l2: TLabel;
     ln: TLabel;
     lval: TLabel;
     end;
  TDeviceDef = record
     name: String;
     hint: String;
     imin, imax: integer;
     fmin, fmax: String;
     scale, offset: Real;
     dir: integer;
     Changed: boolean;
     changedVal: integer;
     isSpecial: boolean;
     isYbar: boolean; // mark vertical scrollbars (need to invert position)
     offsetPost: integer;
     { for shifting imin..imax to fit the Win controls' -32768..32767 range,
       in case imax>32767. }
     typ: char;
     widgetSet: TWidgetSet;
     end;
  TPDeviceDef = ^TDeviceDef;
  TDeviceArray = array [0.. MaxInt div sizeof(TDeviceDef)-1] of TDeviceDef;

  TDevices = class
     private
        anyChanged: boolean;
        currentDevice: integer;
        Cnt: integer;
        Special: integer;
     public
        Device: ^TDeviceArray;
        constructor Create;
        procedure init(n: integer);
        procedure updateLabel(n: integer; v: integer);
        procedure updatePos(n: integer; v: integer);
        procedure flush;
        function Count: integer;
        function vCount: integer;
        procedure resetAnyChanged;
        procedure resetChanged(n: integer);
        procedure addDevice(def: PChar);
        procedure disableControls;
        procedure enableControls;
        function Changed(n: integer): boolean;
        function Val(n: integer): integer;
        procedure controlChange(Sender: TObject);
        procedure abortChange(Sender: TObject);
        function writables: boolean;
     end;

  { Need to create custom record, having an extra word past the end of
    wave parameters }
  TGSMWaveFormat = packed record
     wfx: TWaveFormatEx;
     wSamplesPerBlock: Word;
     end;

  TServerEntry = record
     url: String;
     name: String;
     end;

  function Tokenizer(var P: PChar): TNameVal;
  procedure SafeSetChecked(Chk: TCheckBox; val: boolean);
  procedure SafeSetPos(Dev: TPDeviceDef; p: integer);
  procedure terminateSession;
  function encode(s: String): string;
  function decode(s: String): string;
  function buildServerList(ini: TIniFile): integer;

  //procedure debug(text: String);

{$IFDEF ITA}
 const LANG = 2000;
{$ELSE}
 const LANG = 1000;
{$ENDIF}
const audiobufsize = 650;
const Palantir_HTTP_response = 'HTTP/1.0 200 OK';
const versionNumber = '2.4';
const protocolVersion = '1';
const versionString = 'pclient/ack '+versionNumber+' ['+protocolVersion+'] (Win32)';

var
  Devices: TDevices;
  viewForm: TviewForm;
  loading: boolean = false;
  Jim: TJPEGImage;
  ms: TMemoryStream;
  HackStream: THackStream;
  HttpPhase: THttpPhase;
  AudioPhase: TAudioPhase = AUD_MUTE;
  rcvlen: integer;
  rcvd_a: integer;
  JPEGlen: integer;
  idx: integer;
  Buf: PChar;
  Frames: integer;
  time0, time1: TDateTime;
  TotSize: integer;
  GSMWaveFormat: TGSMWaveFormat;
  audiobuf: array [0..audiobufsize-1] of char;
  xpos: integer = -1;
  ypos: integer = -1;
  zpos: integer = -1;
  ctlStatus: TCtlStatus;
  connStatus: TConnStatus = CONN_UNCONNECTED;
  ctlCountdown: integer;
  formShrinked: boolean;
  formMinHeight: integer;
  sensorHeight: integer = 45;
  muteAudio: boolean;
  savedParams: String;
  currentSensor: integer;
  blankString: String = '';
  framexsize: integer;
  frameysize: integer;
  sensorChanged: boolean;
  connectionErrorLog: integer;
  resizing: boolean = false;
  servers: array [0..9] of TServerEntry;

implementation

{$IFDEF DEBUG}
uses debugger;
{$ENDIF}

uses ResourceLocalizer;

{$R *.DFM}
{$R local.RES}

constructor TDevices.Create;
begin
 Cnt:=0;
end;

function TDevices.Count: integer;
begin
 result:= Cnt;
end;

function TDevices.vCount: integer;
begin
 result:=Cnt-Special;
end;

procedure TDevices.init(n: integer);
begin
 anyChanged:=false;
 currentDevice:=0;
 Special:=0;
 Device:=AllocMem(n*sizeof(TDeviceDef));
 Cnt:=n;
 ViewForm.zoomWLabel.Visible:=false;
 ViewForm.zoomTLabel.Visible:=false;
 ViewForm.zoomLabel.Visible:=false;
end;

procedure TDevices.resetAnyChanged;
begin
 anyChanged:=false;
end;

procedure TDevices.resetChanged(n: integer);
begin
 Device^[n].Changed:=false;
end;

function TDevices.Val (n: integer): integer;
begin
 result:=Device^[n].changedVal;
{
 if Device^[n].typ='t' then
    result:=(Device^[n].widgetset.wc as TTrackBar).Position
 else if Device^[n].typ='s' then
    result:=(Device^[n].widgetset.wc as TScrollBar).Position
 else result:=0;
}
end;

function TDevices.Changed(n: integer): boolean;
begin
 result:=Device^[n].Changed;
end;

procedure TDevices.disableControls;
var i: integer;
begin
 for i:=0 to Count-1 do
    if Device^[i].typ='t' then
       Device^[i].widgetSet.wc.Enabled:=false;
end;

procedure TDevices.enableControls;
var i: integer;
begin
 for i:=0 to Cnt-1 do
    if Device^[i].dir > 0 then
       Device^[i].widgetSet.wc.Enabled:=true;
end;

function TDevices.writables: boolean;
var i: integer;
begin
 result:=true;
 for i:=0 to Cnt-1 do
    if Device^[i].dir > 0 then exit;
 result:=false;
end;

procedure TDevices.updateLabel(n: integer; v: integer);
begin
 with Devices.Device^[n] do begin
    ///if not isSpecial then
    widgetSet.lval.Caption:=FloatToStrF(scale*v+offset,
       ffGeneral,5,1);
    end;
    //SafeSetPos(@Devices.Device^[n],StrToInt(v));
end;

procedure TDevices.updatePos(n: integer; v: integer);
begin

 with Device^[n] do begin
    v:=v-offsetPost;
    if csLButtonDown in widgetSet.wc.ControlState then exit;
    if (typ='t') then
       with widgetSet.wc as TTrackBar do begin
          //onChange:=nil;
          Position:=v;
          //onChange:=Devices.controlChange;
          end
    else if (typ='p') then
       with widgetSet.wc as TProgressBar do begin
          Position:=v;
          end
    else if (typ='s') then
       with widgetSet.wc as TScrollBar do begin
          if isYbar then v:=imin+imax-v;
          onChange:=nil;
          Position:=v;
          onChange:=Devices.controlChange;
          end
    end
end;

constructor TLogger.Create(lbl: TLabel);
begin
 target:=lbl;
 currLevel:=LOG_INFO;
end;

procedure TLogger.log(s: String; level: TLogLevel);
begin
 if level>=currLevel then target.Caption:=s;
 if level=LOG_FAIL then failure:=s;
{$IFDEF DEBUG}
 debug(s);
{$ENDIF}
end;

function TLogger.isFailure: boolean;
begin
 result:=  (failure<>'');
end;

procedure TLogger.Clean;
begin
 target.Caption:='';
 failure:='';
 currlevel:=LOG_INFO;
end;

procedure TviewForm.WSock1DataAvailable(Sender: TObject; Error: Word);
 var Len: integer;
    secs: double;
    P: PChar;
    hbuf: array [0..2047] of char;
    params: String;
    ctlTime: integer;
    sensorDef: PChar;
begin
 if HttpPhase in [firstheader, headers, expectframeinfo, frameinfo, flush] then begin
    Len:=TCustomLineWSocket(Sender).Receive(@hbuf,Sizeof(hbuf));
    if HttpPhase = flush then exit;

    if (Len <= 0) then exit;
    P:=StrScan(hbuf,#13);
    if (P = nil) or ((P-hbuf) >= Len) then begin
       Logger.Log(TResourceLocalizer.GetString(LANG,4),LOG_FAIL);
       WSock1.closeDelayed;
       exit;
       end;
    P^:= #0;

    if HttpPhase = firstHeader then begin
       if StrComp(hbuf,Palantir_HTTP_response)<>0 then begin
          Logger.Log(TResourceLocalizer.GetString(LANG,4),LOG_FAIL);
          WSock1.closeDelayed;
          exit;
          end
       else begin
          HttpPhase:=headers;
          exit
          end
       end;

    if HttpPhase = headers then begin
       { ctlButton is enabled only if it makes sense, i.e. there
         are writable devices and/or audio. }
       if P = hbuf then begin // no more global headers
          ServerHasAudio:= (TCPAudioPort<>-1);
          if Devices.writables or ServerHasAudio then
             ctlButton.Enabled:=true;
          HttpPhase:=frameinfo;
          JPEGLen:=0;
          exit;
          end;

       {$IFDEF DEBUG}
       debug(hbuf);
       {$ENDIF}

       if StrLComp(hbuf,'X-Protocol-Version: ',20) = 0 then begin
          if strtoint(hbuf+20)>strtoint(protocolVersion) then begin
             Logger.Log(TResourceLocalizer.GetString(LANG,5)+PChar(hbuf+20)+TResourceLocalizer.GetString(LANG,6),LOG_FAIL);
             HttpPhase:=flush;
             WSock1.closeDelayed;
             exit;
             end
          end;
       if StrLComp(hbuf,'X-Defined-Sensors: ',19) = 0 then begin
          if Devices.Count >0 then Devices.flush;
          Devices.init(strtoint(hbuf+19));
          end
       else if StrLComp(hbuf,'X-Sensor-Define: ',17) = 0 then begin
          sensorDef:=hbuf+17;
          Devices.addDevice(sensorDef);
          end
       { obsolete 'X-Audio: ' is still checked for compatibility }
       else if StrLComp(hbuf,'X-Audio: ',9) = 0 then begin
          TCPAudioPort:=TCPPort+1;
          end
       else if StrLComp(hbuf,'X-Audio-Port: ',14) = 0 then begin
          TCPAudioPort:=strtoint(hbuf+14);
          end
       else if StrLComp(hbuf,'X-Greeting: ',12) = 0 then begin
          viewForm.Caption:=hbuf+12;
          end
       { too many streaming clients, so server sent us a single snapshot.
       'X-Snapshot: 1' marks end of non-frame-specific headers }
       else if StrLComp(hbuf,'X-Snapshot: 1',13) = 0 then begin
          Logger.Log(TResourceLocalizer.GetString(LANG,7),LOG_FAIL);
          HttpPhase:=frameinfo;
          end;
       end // headers

    else if HttpPhase = expectframeinfo then begin
       if P = hbuf then begin
          HttpPhase:=frameinfo;
          JPEGLen:=0;
          exit;
          end;
       end

    else if HttpPhase = frameinfo then begin
       if P = hbuf then begin
          HttpPhase:=framebody;
          WSock1.LineMode:=false;
          rcvlen:=0;
          if JPEGlen=0 then begin
             ackTimer.Interval:=2000;
             ackTimer.Enabled:=true;
             end;
          exit;
          end;
       if StrLComp(hbuf,'Content-Length: ',16) = 0 then begin
          rcvlen:=0;
          JPEGlen:=strtoint(string(@hbuf[16]));
          exit
          end
       else if StrLComp(hbuf,'X-Index: ',9) = 0 then begin
          idx:=strtoint(string(@hbuf[9]));
          exit
          end
       else if StrLComp(hbuf,'X-Sensor-Change: ',17) = 0 then begin
          {$IFDEF DEBUG}
          debug('Frame '+IntToStr(frames)+': '+hbuf);
          {$ENDIF}
          updateGauges(hbuf+17);
          exit
          end
       else if StrLComp(hbuf,'X-Ctl-Delay: ',13) = 0 then begin
          ctlTime:=strtoint(string(@hbuf[13]));
          if ctlStatus = CTL_PENDING then
             if ctlTime = -1 then begin
                Logger.log(TResourceLocalizer.GetString(LANG,10),LOG_INFO);
                ctlStatus:=CTL_DEQUEUED;
                end
          else Logger.Log(TResourceLocalizer.GetString(LANG,9)+ IntToStr(ctlTime) + ' s...',LOG_INFO);
          end
       else if StrLComp(hbuf,'X-Ctl-Expiry: ',14) = 0 then begin
          ctlTime:=strtoint(string(@hbuf[14]));
          if ctlTime = 0 then begin
             ctlTimer.Enabled:=false;
             Logger.Log(TResourceLocalizer.GetString(LANG,8),LOG_INFO);
             loseControl;
             end
          else if ctlStatus = CTL_PENDING then begin
             gainControl(ctlTime);
             ctlCountdown:=ctlTime;
             ctlButton.Caption:=IntToStr(ctlCountdown);
             ctlTimer.Enabled:=true;
             end
          end
       else if StrLComp(hbuf,'X-Audio-Start: ',15) = 0 then begin
          audioStart;
          end;
       end; // frameinfo
    end;  // headers OR frameinfo
 if HttpPhase = framebody then begin
    try
    Len:=TCustomLineWSocket(Sender).Receive(@Buf[rcvlen],JPEGlen-rcvlen);
    if Len <= 0 then exit;
    rcvlen := rcvlen + Len;
    if rcvlen = JPEGlen then begin
       params:=BuildParamString();
       if params<>'' then
          Logger.Log('Frame '+IntToStr(Frames)+': '+params,LOG_NULL);
       if ctlStatus = CTL_ASKING then begin
          addParam(params,'k=1');
          ctlStatus:=CTL_PENDING;
          end;
       WSock1.SendStr(params + #13#10);
       WSock1.Flush;
       ShowImage(PChar(@buf[0]));
       //Application.ProcessMessages;    // everything hangs
       TotSize:=TotSize+JPEGlen;
       Inc(Frames);
       if (frames and 7) = 0 then begin
          secs:=(now-time1)*24*3600;
          time1:=now;
          if menu_fr.Checked then
             Logger.Log(FloatToStrF(8/secs,ffFixed,3,2) + ' f/s',LOG_INFO);
          end;

       HttpPhase:=expectframeinfo;
       WSock1.LineMode:=true;
       end;
    except
       on ESocketException do begin
          Logger.log(TResourceLocalizer.GetString(LANG,31),LOG_CRIT);
          end
       else
          raise;
    end;
    end;
end;



procedure TViewForm.addParam (var s: String; par: String);
begin
   if s <> '' then s := s + '; ';
   s := s + par;
end;


function TViewForm.BuildParamString: String;
var i: integer;
begin
 result:='';
 if (ctlStatus=CTL_CURRENT) then begin

   // lock
   if Devices.anyChanged then begin
      for i:=0 to Devices.Count-1 do
         if Devices.Changed(i) then begin
            Devices.resetChanged(i);
            addParam(result,'c'+IntToStr(i)+'='+IntToStr(Devices.Val(i)));
            end;
      Devices.resetAnyChanged;
      end;
   // unlock

   if (audioPhase=AUD_TALKING) and muteAudio then begin
      addParam(result,'a=0');
      audioPhase:=AUD_MUTING;
      muteAudio:=false;
      end
   else if audioPhase=AUD_ASKING then begin
      addParam(result,'a=1');
      audioPhase:=AUD_PENDING;
      end;
   end; // in control
   if blankString<>'' then begin
      addParam(result,blankString);
      blankString:='';
      end;
   { server expects text to be passed as the last parameter, to prevent
     things like '; c5=44' - which could legally appear in the
     transmitted text - to be interpreted as extra params.
     Never trust the clients! ';' is usually encoded, but malicious
     users could transmit them unencoded }
   if (srvEdit.Enabled=false) and (srvEdit.Text<>'') then begin
      addParam(result,'t='+encode(srvEdit.Text));
      srvEdit.Text:='';
      srvEdit.Enabled:=true;
      end;
end;

function encode(s: String): string;
var i: integer;
begin
 result:='';
 for i := 1 to Length(s) do begin
    if (s[i]=';') or (s[i]='%') or (s[i]=' ') then
       result:=result+'%'+inttohex(Ord(s[i]),2)
    else result:=result+s[i];
    end
end;

function decode(s: String): string;
var i,n,v,val: integer;
begin
 result:=''; n:=0; val:=0;
 for i := 1 to Length(s) do begin
    if (s[i]='%') then begin
       n:=1;
       continue;
       end
    else if (n>0) then begin
       if ((s[i]>='0') and (s[i]<='9') or (s[i]>='A') and (s[i]<='F')) then begin
          Inc(n);
          v:=Ord(s[i])-48;
          if (s[i]>='A') then v:=v-7;
          if n=2 then val:=v*16
          else if n=3 then begin
             val:=val+v;
             result:=result+Chr(val);
             n:=0; val:=0;
             end;
          continue;
          end
       else n:=0;
       end;
    result:=result+s[i];
    end;
end;

//procedure TViewForm.ParseSensor(n: integer; def: PChar);
procedure TDevices.addDevice(def: PChar);
var nv: TNameVal;
    PtmpSB: TTrackBar;
    PtmpPB: TProgressBar;
    widgetsBaseline: integer;
    controlWidth: integer;
begin
 {$IFDEF DEBUG}
 debug('Parsing device '+Inttostr(currentDevice)+' ('+def+')');
 {$ENDIF}

 with Device^[currentDevice] do begin
    isSpecial:=false; isYbar:=false;
    imin:=0; imax:=0;
    fmin:='0'; fmax:='0';
    dir:=0;
    offsetPost:=0;
    end;

 while true do begin
    nv:=Tokenizer(def);
    if nv.Name='' then break;
    if nv.Name='name' then Device^[currentDevice].name:=nv.value
    else if nv.Name='hint' then Device^[currentDevice].hint:=nv.value
    else if nv.Name='imax' then Device^[currentDevice].imax:=StrToInt(nv.value)
    else if nv.Name='imin' then Device^[currentDevice].imin:=StrToInt(nv.value)
    else if nv.Name='fmax' then Device^[currentDevice].fmax:=nv.value
    else if nv.Name='fmin' then Device^[currentDevice].fmin:=nv.value
    else if nv.Name='dir'  then Device^[currentDevice].dir:=StrToInt(nv.value)
    else if nv.Name='type' then begin
       if nv.value='s' then
          { the only "slider" widget we recognize from the server is the
            trackbar, apart from the pan/tilt/zoom "true" sliders -
            which must be transmitted as 'x' 'y' 'z' }
          Device^[currentDevice].typ:='t'
       else
          Device^[currentDevice].typ:=PChar(nv.value)[0];
       if (nv.value='x') or (nv.value='y') or (nv.value='z') then begin
          Inc(Special);
          Device^[currentDevice].isSpecial:=true;
          end;
       end;
    if def = nil then break;
    end;

 controlWidth:=330;

 if Device^[currentDevice].imax>32767 then
    Device^[currentDevice].offsetPost:=32768;

 with Device^[currentDevice] do
    try
       scale:=(StrToFloat(fmax)-StrToFloat(fmin))/(imax-imin);
       offset:=StrToFloat(fmin)-scale*imin;
    except on E: Exception do
       scale:=0;
    end;

 if Device^[currentDevice].isSpecial then begin
    with Device^[currentDevice] do begin
       if typ='x' then begin
          widgetSet.wc:=ViewForm.xScrollBar;
          widgetSet.lval:=ViewForm.xvalLabel;
          widgetSet.lval.visible:=ViewForm.menu_lbl.Checked;
          end
       else if typ='y' then begin
          isYbar:=true;
          widgetSet.wc:=ViewForm.yScrollBar;
          widgetSet.lval:=ViewForm.yvalLabel;
          widgetSet.lval.visible:=ViewForm.menu_lbl.Checked;
          end
       else if typ='z' then begin
          widgetSet.wc:=ViewForm.zScrollBar;
          widgetSet.lval:=ViewForm.zvalLabel;
          widgetSet.ln:=ViewForm.zoomLabel;
          widgetSet.lval.visible:=ViewForm.menu_lbl.Checked;
          if name='Zoom' then begin
             ViewForm.zoomWLabel.Visible:=true;
             ViewForm.zoomTLabel.Visible:=true;
             end
          else begin
             widgetSet.ln.Visible:=true;
             widgetSet.ln.Caption:=name;
             widgetSet.ln.Hint:=hint;
             end;
          end;
       typ:='s';
       widgetSet.wc.Visible:=true;
       widgetSet.wc.Enabled:=true;
       (widgetSet.wc as TScrollBar).SetParams((imin+imax) div 2,imin,imax);
       end;

    end

 else begin

 // non-special controls

 if Device^[currentDevice].typ='t' then begin
    PtmpSB:=TTrackBar.Create(sensorForm);
    Device^[currentDevice].widgetSet.wc:=PtmpSB;
    with Device^[currentDevice].widgetSet.wc as TTrackBar do begin
       min:=-32767; max:=32768;
       min:=Device^[currentDevice].imin-Device^[currentDevice].offsetPost;
       max:=Device^[currentDevice].imax-Device^[currentDevice].offsetPost;
       TickStyle:=tsNone;
       Height:=24;
       Position:=min;
       //Height:=10;
       end;
    end
 else if Device^[currentDevice].typ='p' then begin
    PtmpPB:=TProgressBar.Create(sensorForm);
    Device^[currentDevice].widgetSet.wc:=PtmpPB;
    with Device^[currentDevice].widgetSet.wc as TProgressBar do begin
       min:=-32767; max:=32768;
       min:=Device^[currentDevice].imin-Device^[currentDevice].offsetPost;
       max:=Device^[currentDevice].imax-Device^[currentDevice].offsetPost;
       Position:=min;
       end;
    end;

 widgetsBaseline:=20+(currentDevice-Special)*sensorheight;
 with Device^[currentDevice].widgetSet do begin
    l1:=TLabel.Create(sensorForm);
    l1.Parent:=sensorForm;
    l1.Visible:=true;
    l1.left:=9;
    l1.top:=widgetsBaseline+18;
    l1.caption:=Device^[currentDevice].fmin;

    l2:=TLabel.Create(sensorForm);
    l2.Parent:=sensorForm;
    l2.Visible:=true;
    l2.left:=9+(controlWidth-9) div 2;
    l2.width:=controlWidth div 2;
    l2.autosize:=false;
    l2.top:=widgetsBaseline+18;
    l2.caption:=Device^[currentDevice].fmax;
    l2.alignment:=taRightJustify;

    lval:=TLabel.Create(sensorForm);
    lval.Parent:=sensorForm;
    lval.Visible:=true;
    lval.left:=controlWidth+30;
    lval.top:=widgetsBaseline+18;
    lval.caption:=IntToStr(Device^[currentDevice].imin);
    lval.hint:=Device^[currentDevice].hint;

    ln:=TLabel.Create(sensorForm);
    ln.Parent:=sensorForm;
    ln.Visible:=true;
    ln.left:=controlWidth+30;
    ln.top:=widgetsBaseline;
    ln.caption:=Device^[currentDevice].name;
    ln.hint:=Device^[currentDevice].hint;

    end;

 with Device^[currentDevice].widgetSet.wc do begin
    Parent:=sensorForm;
    top:=widgetsBaseline;
    left:=9;
    width:=327;
    if Device^[currentDevice].typ='t' then begin
       top:=top-8;
       left:=left-8;
       width:=width+16;
       end;
    Visible:=true;
    TabStop:=false;
    //Hint:=Device^[currentDevice].hint;
    showHint:=true;
    if Device^[currentDevice].typ='p' then
       Enabled:=true
    else Enabled:=false;
    end;

 // end non-special controls
 end;

 with Devices.Device^[currentDevice] do begin
    if typ='s' then begin
       //if isSpecial then
          //(widgetSet.wc as TScrollBar).onChange:=abortChange
       //else
          (widgetSet.wc as TScrollBar).onChange:=controlChange
       end
    else if typ='t' then
       (widgetSet.wc as TTrackBar).onChange:=controlChange;
    widgetSet.wc.Tag:=currentDevice;
    end;

 Inc(currentDevice);

 if currentDevice=Cnt then begin
    viewForm.sensorBox.Enabled:=(Count-Special>0);
    if Count-Special=0 then begin
       sensorForm.visible:=false;
       SafeSetChecked(viewForm.sensorBox,false);
       end;
    sensorForm.Height:=40+(Count-Special)*sensorheight;
    end;

end;

procedure TDevices.flush;
var i: integer;
begin
 for i:=0 to Cnt-1 do
    with Device^[i].widgetSet do begin
       if not Device^[i].isSpecial then begin
          wc.Free;
          l1.Free;
          l2.Free;
          ln.Free;
          lval.Free;
          end
       else with wc as TScrollBar do begin
          visible:=false;
          //OnChange:=nil;
          { when reconnecting after gaining control, controlState for the
            "special" sliders contains csLButtonDown, which causes trouble
            with the check in updatePos; better to explicitly clean it }
          ControlState:=[];
          end
    end;
 if Cnt>0 then FreeMem(Device);
 Cnt:=0;
end;


function Tokenizer(var P: PChar): TNameVal;
var c,e: PChar;
begin
 result.Name:='';
 result.Value:='';
 if P=nil then exit;
 while P^=' ' do Inc(P);
 c:=StrScan(P, ';');
 if c <> nil then c^:=#0;
 e:=StrScan(P, '=');
 if e = nil then begin
    P:=nil;
    exit;
    end;
 e^:=#0;
 result.Name:=P;
 result.Value:=decode(e+1);
 P:=c;
 if P <> nil then Inc(P);
end;


procedure TViewForm.updateGauges(s: PChar);
var nv: TNameVal;
    n: integer;
begin
 while true do begin
    nv:=Tokenizer(s);
    if nv.Name='' then break;
    if PChar(nv.Name)[0]='c' then begin
       n:=StrToInt(1+PChar(nv.Name));
       if (n<0) or (n>=Devices.Count) then continue;
       Devices.updatePos(n,StrToInt(nv.value));
       Devices.updateLabel(n,StrToInt(nv.value));
       end;
    if s = nil then break;
    end;
end;


procedure TViewForm.loseControl;
begin
   ctlStatus:=CTL_DEQUEUED;
   ctlButton.Caption:=TResourceLocalizer.GetString(LANG,111);
   ctlTimer.Enabled:=false;
   SafeSetChecked(audioBox,false);
   audioBox.Enabled:=false;
   Devices.disableControls;
end;

procedure TViewForm.gainControl(t: integer);
begin
   Logger.Log(TResourceLocalizer.GetString(LANG,11)+IntToStr(t)+' s.',LOG_INFO);
   ctlStatus:=CTL_CURRENT;
   if serverHasAudio and (audioInputEnabled or audioOutputEnabled) then
      audioBox.Enabled:=true;
   Devices.enableControls;
end;


Procedure TviewForm.ShowImage(P: PChar);
begin
    if Image1.Picture = nil then Image1.Picture:=TPicture.Create;
    HackStream.SetPointer(P,JPEGlen);
    HackStream.Seek(0,soFromBeginning);
    Jim.LoadFromStream(HackStream);
    if (Jim.width<>framexsize) or (Jim.height<>frameysize) then begin
       framexsize:=Jim.width;
       frameysize:=Jim.height;
       setImageSize;
       end;
    Image1.Picture.Graphic:=Jim;
end;


procedure TviewForm.Connect;
var srv,s: String; n: integer;
begin
    if not menu_msg.Checked then begin
       s:=Srvedit.Text;
       cachedServer:=Srvedit.Text;
       end
    else
       s:=cachedServer;

    TCPPort:=3000;

    n:=Pos(':',s);
    if n>0 then begin
       srv:=Copy(s,1,n-1);
       TCPPort:=StrToInt(PChar(s)+n);
       end
    else srv:=s;
    if srv='' then exit;

    connStatus:=CONN_CONNECTING;
    Logger.Clean;
    streamBtn.Caption:='Stop';

    WSock1.port:=IntToStr(TCPPort);
    WSock1.proto:='tcp';
    WSock1.LineMode:=False;
    Logger.Log(TResourceLocalizer.GetString(LANG,12)+srv+'...',LOG_CRIT);
    Frames:=0; // so that frames count is not logged upon disconnection
    connectionErrorLog:=0;
    WSock1.DNSLookup(srv);
end;

procedure TviewForm.Disconnect;
begin
    WSock1.close;
    audioSock.close;
    ctlTimer.Enabled:=false;
    loseControl;
end;

procedure TviewForm.streamBtnClick(Sender: TObject);
begin
 if connStatus=CONN_UNCONNECTED then Connect
 else if connStatus=CONN_CONNECTING then begin
    WSock1.CancelDNSLookup;
    Logger.Log(TResourceLocalizer.GetString(LANG,13),LOG_FAIL);
    terminateSession;
    end
 else if connStatus=CONN_CURRENT then Disconnect;
end;


procedure TviewForm.WSock1DnsLookupDone(Sender: TObject; Error: Word);
begin
 if Error<>0 then begin
    Logger.Log(TResourceLocalizer.GetString(LANG,14),LOG_FAIL);
    terminateSession;
    end
 else try
    WSock1.Addr:=WSock1.DNSResult;
    Logger.log(TResourceLocalizer.GetString(LANG,15)+WSock1.Addr+'...',LOG_CRIT);
    WSock1.Connect;
    except on ESocketException do begin
       Logger.Log(TResourceLocalizer.GetString(LANG,16),LOG_FAIL);
       terminateSession;
       end
    end

end;


procedure TviewForm.WSock1SessionConnected(Sender: TObject; Error: Word);
begin
 { this event is triggered even on connect failures,
   and WSock1.State can be =wsConnected even after a failure!
   The reliable way to handle such cases is check the Error variable }
 if Error<>0 then begin
    Logger.Log(TResourceLocalizer.GetString(LANG,17),LOG_FAIL);
    terminateSession;
    exit;
 end;

 ServerURL:=cachedServer;
 Logger.log(TResourceLocalizer.GetString(LANG,18),LOG_CRIT);
 WSock1.SendStr('GET /' + #13#10);
 WSock1.SendStr('User-Agent: '+versionString+ #13#10#13#10);
 connStatus:=CONN_CURRENT;
 streamBtn.Caption:=TResourceLocalizer.GetString(LANG,113);
 streamBtn.Enabled:=True;
 //ctlButton.Enabled:=true;
 framexsize:=0;
 frameysize:=0;
 time0:=now;
 time1:=time0;
 TotSize:=0;
 HttpPhase:=firstheader;
 audioPhase:=AUD_MUTE;
 WSock1.LineMode:=true;
 WSock1.LineEnd:=#13#10;
 rcvlen:=0;
 muteAudio:=false;
 TCPAudioPort:=-1;
 if not videoBox.checked then blankString:='v=0';
 loseControl;
end;

procedure TviewForm.WSock1SessionClosed(Sender: TObject; Error: Word);
var secs: double;
begin
 terminateSession;
 secs:=(now-time0)*24*3600;
 if (secs>0) and (Frames>1) then
    Logger.Log(TResourceLocalizer.GetString(LANG,19)+IntToStr(Frames)+
       TResourceLocalizer.GetString(LANG,20)+
       FloatToStrF(secs,ffFixed,3,2)+' s ('+
       FloatToStrF(Frames/secs,ffFixed,3,2)+' f/s, '+
       FloatToStrF((TotSize/Frames)/1000,ffFixed,3,1)+' kB/f)',LOG_CRIT)
 else
    if not Logger.isFailure then
       Logger.Log(TResourceLocalizer.GetString(LANG,21),LOG_CRIT);
 loseControl;
end;


procedure terminateSession;
begin
 connStatus:=CONN_UNCONNECTED;
 viewForm.srvEdit.Enabled:=true;
 viewForm.streamBtn.Caption:=TResourceLocalizer.GetString(LANG,112);
 viewForm.ctlButton.Enabled:=false;
 viewForm.WSock1.Close;
end;


procedure TviewForm.audio(Sender: TObject);
begin
 if (connStatus<>CONN_CURRENT) or (ctlStatus<>CTL_CURRENT) then exit;
 if audioPhase = AUD_MUTE then begin
    audioBox.Enabled:=false;
    audioPhase:=AUD_ASKING;
    end
 else begin
    muteAudio:=true;
    audioBox.Enabled:=false;
    end
end;

procedure TViewForm.audioStart;
begin
    if audioOutputEnabled then ACMWaveOut1.Open(@GSMWaveFormat);
    if audioInputEnabled then ACMWaveIn1.Open(@GSMWaveFormat,viewForm.Handle);
    audioSock.Addr:=WSock1.Addr;
    audioSock.proto:='tcp';
    audioSock.port:=IntToStr(TCPAudioPort);
    audioSock.LineMode:=False;
    try
       audiosock.Connect;
       except on ESocketException do begin
          Logger.Log(TResourceLocalizer.GetString(LANG,22),LOG_CRIT);
          audioPhase:=AUD_MUTE;
          exit
          end
       end
end;

procedure TviewForm.audiosockSessionConnected(Sender: TObject;
  Error: Word);
begin
   //InfoLabel.Caption:='Connected to audio stream';
   rcvd_a:=0;
   audioPhase:=AUD_TALKING;
   audioBox.Enabled:=true;
end;

procedure TviewForm.audiosockSessionClosed(Sender: TObject; Error: Word);
begin
 ACMWaveIn1.close();
 ACMWaveOut1.Close();
 audioPhase:=AUD_MUTE;
 if ctlStatus<>CTL_CURRENT then SafeSetChecked(audioBox,false)
 else audioBox.Enabled:=true;
end;

procedure TviewForm.audiosockDataAvailable(Sender: TObject; Error: Word);
var l: integer;
begin
   while rcvd_a<audiobufsize do begin
      l:=audiosock.Receive(@audiobuf[rcvd_a],audiobufsize-rcvd_a);
      if l<=0 then begin
         exit;
         end;
      rcvd_a:=rcvd_a+l;
      end;
   rcvd_a:=0;
   ACMWaveOut1.Playback(@audiobuf[0],audiobufsize);
end;

procedure TviewForm.ACMWaveInData(data: Pointer; size: Integer);
begin
   if audiosock.state=wsConnected then begin
      audiosock.Send(data,size);
      audiosock.Flush;
   end
end;

procedure TviewForm.FormCreate(Sender: TObject);
var
  audioError, audioMsg: String;
  ai, ao, i, n: integer;
  pclientIni: TIniFile;
  autoconnect: boolean;
begin
 autoconnect:=false;
 audioError:='';
 DecimalSeparator:='.';
 Image1.Height:=240;
 Image1.Width:=320;
 Jim:=TJPEGImage.Create;
 ms:=TMemoryStream.Create;
 HackStream:=THackStream.Create;
 getmem(Buf,100000);
 with GSMWaveFormat do begin
    with wfx do begin
       wFormatTag:=49;
       nChannels:=1;
       nSamplesPerSec:=8000;
       nAvgBytesPerSec:=1625;
       nBlockAlign:=65;
       wBitsPerSample:=0;
       cbSize:=2;
       end;
    wSamplesPerBlock:=320;
    end;
 formShrinked:=true;
 formMinHeight:=404;

 sensorsFirstPopUp:=true;
 cachedServer:=srvEdit.text;
 ViewForm.Height:=formMinHeight;
 Logger:=TLogger.Create(ctlLabel);
 Devices:=TDevices.Create;
 xScrollBar.Enabled:=true;
 if assigned(Application.OnMessage) then AppOldMsgHandler:=Application.OnMessage
 else AppOldMsgHandler:=nil;
 Application.OnMessage:=appMsgHandler;
 chnLabel.Caption:=TResourceLocalizer.GetString(LANG,100);
 videoBox.Caption:=TResourceLocalizer.GetString(LANG,101);
 audioBox.Caption:=TResourceLocalizer.GetString(LANG,102);
 sensorBox.Caption:=TResourceLocalizer.GetString(LANG,103);
 ImageMenu.Caption:=TResourceLocalizer.GetString(LANG,104);
 menu_stretch.Caption:=TResourceLocalizer.GetString(LANG,105);
 Display1.Caption:=TResourceLocalizer.GetString(LANG,106);
 menu_msg.Caption:=TResourceLocalizer.GetString(LANG,107);
 menu_fr.Caption:=TResourceLocalizer.GetString(LANG,108);
 menu_lbl.Caption:=TResourceLocalizer.GetString(LANG,109);
{$IFDEF ITA}
 menu_lbl.visible:=false;
{$ENDIF}
 ServerMenu.Caption:=TResourceLocalizer.GetString(LANG,110);
 ctlButton.Caption:=TResourceLocalizer.GetString(LANG,111);
 streamBtn.Caption:=TResourceLocalizer.GetString(LANG,112);
 ctlLabel.Caption:=TResourceLocalizer.GetString(LANG,23)+versionNumber+'.';
 viewForm.Caption:=TResourceLocalizer.GetString(LANG,114);

 ACMWaveOut1:=TACMWaveOut.Create;
 audioOutputEnabled:=true;
 ao:=ACMWaveOut1.Open(@GSMWaveFormat);
 if ao<>0 then begin
    audioError:=audioError + TResourceLocalizer.GetString(LANG,24);
    if ao<>WAVERR_BADFORMAT then
       audioError:=audioError+' (error '+IntToStr(ao)+')';
    audioError:=audioError+'.'+#13;
    audioOutputEnabled:=false;
    end;

 ACMWaveIn1:=TACMWaveIn.Create;
 ACMWaveIn1.userCallback:=ACMWaveInData;
 audioInputEnabled:=true;
 ai:=ACMWaveIn1.Open(@GSMWaveFormat,Handle);
 if ai<>0 then begin
    audioError:=audioError+TResourceLocalizer.GetString(LANG,25);
    if (ai<>WAVERR_BADFORMAT) and (ai<>MMSYSERR_ALLOCATED) then
       audioError:=audioError+' (error '+IntToStr(ai)+')';
    audioError:=audioError+'.'+#13;
    audioInputEnabled:=false;
    end;

 if (ao<>0) or (ai<>0) then begin
    audioMsg:=TResourceLocalizer.GetString(LANG,26);
    if (ai=MMSYSERR_BADDEVICEID) or (ao=MMSYSERR_BADDEVICEID) then
       audioError:=audioError+
          TResourceLocalizer.GetString(LANG,27)+#13;
    if (ai=WAVERR_BADFORMAT) or (ao=WAVERR_BADFORMAT) then
       audioError:=audioError+
          TResourceLocalizer.GetString(LANG,28)+#13;
    if ai=MMSYSERR_ALLOCATED then begin
       audioError:=audioError+
          TResourceLocalizer.GetString(LANG,29)+#13;
       audioMsg:=TResourceLocalizer.GetString(LANG,30);
       end;
    messageDlg(audioError+#13+audioMsg,mtWarning,[mbOK],0);
    end;
 ACMWaveOut1.Close;
 ACMWaveIn1.Close;
 serverHasAudio:=true;

 if FileExists(getCurrentDir+'\pclient.ini') then begin
    pclientIni:=TIniFile.Create(getCurrentDir+'\pclient.ini');
    n:=buildServerList(pclientIni);
    autoconnect:=pclientIni.ReadBool('global','autoconnect',false);
    srvEdit.Text:=pclientIni.readString('global','defaultserver','');
    pclientIni.free;
    end
 else begin
{$IFDEF ITA}
    Servers[0].url:='wtb.cc:5050';
    Servers[0].name:='North Salt Lake';
    n:=1;
{$ELSE}
    Servers[0].url:='wtb.cc:5050';
    Servers[0].name:='North Salt Lake';
    Servers[1].url:='afunk.hnf.de';
    Servers[1].name:='Amateur radio @ HNF';
    Servers[2].url:='palantir.santinoli.com:14334';
    Servers[2].name:='santinoli.com #1';
    n:=3;
{$ENDIF}
//    Servers[4].url:='palantir.santinoli.com:14336';
//    Servers[4].name:='santinoli.com #2';
    end;

 for i:=0 to n-1 do begin
    servermenu.add(TMenuItem.Create(ServerMenu));
    servermenu.Items[i].Caption:=Servers[i].name;
    servermenu.Items[i].OnClick:=serverMenuClick;
    end;

 if autoconnect then Connect;
end;

function BuildServerList(ini: TIniFile): integer;
var
 n: integer;
 s: String;
 p: PChar;
begin
 n:=0;
 repeat
    s:=ini.ReadString('serverlist','server'+IntToStr(n),'');
    if s='' then break;
    p:=strScan(PChar(s),',');
    if p<>nil then p^:=#0;
    Servers[n].url:=Trim(s);
    if (p<>nil) and ((p+1)^<>#0) then
       Servers[n].name:=Trim(p+1)
    else
       Servers[n].name:=Servers[n].url;
    Inc(n);
    until n>9;
 Result:=n;
end;

procedure TviewForm.adjustFormHeight;
begin
 if Devices.Count = 0 then exit;
    viewForm.Height:=formMinHeight + (Devices.Count-3) * sensorHeight
end;


procedure TviewForm.sensorBtnClick(Sender: TObject);
begin
   if sensorsFirstPopUp then begin
      sensorsFirstPopUp:=false;
      sensorForm.Left:=viewForm.Left+150;
      if sensorForm.Height>Screen.Height-80 then
         sensorForm.Top:=160
      else if sensorForm.Height+viewForm.Top+320>Screen.Height-80 then
         sensorForm.Top:=Screen.Height-80-sensorForm.Height
      else
         sensorForm.Top:=viewForm.Top+320;
      end;
   sensorForm.visible:=sensorBox.Checked;
   if connStatus=CONN_CURRENT then
      sensorForm.Caption:=TResourceLocalizer.GetString(LANG,3)+ serverURL;
end;

procedure TviewForm.ctlButtonClick(Sender: TObject);
begin
 if (connStatus=CONN_CURRENT) and (ctlStatus = CTL_DEQUEUED) then begin
    ctlStatus:=CTL_ASKING;
    Logger.log(TResourceLocalizer.GetString(LANG,2),LOG_INFO);
    end
end;

procedure TviewForm.ctlTimerTimer(Sender: TObject);
begin
 Dec(ctlCountdown);
 ctlButton.Caption:=IntToStr(ctlCountdown);
 if ctlCountdown = 0 then begin
    ctlTimer.Enabled:=false;
    exit
    end;

end;

procedure TviewForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if audioInputEnabled then ACMWaveIn1.Close;
 if audioOutputEnabled then ACMWaveOut1.Close;
end;

procedure TviewForm.ackTimerTimer(Sender: TObject);
var params: String;
begin

 if (JPEGLen=0) and (WSock1.State=wsConnected) then begin
    params:=BuildParamString;
       if ctlStatus = CTL_ASKING then begin
          addParam(params,'k=1');
          ctlStatus:=CTL_PENDING;
          end;
    WSock1.SendStr(params + #13#10);
    WSock1.Flush;
    httpPhase:=headers; // see 'MONSTRE-HACK'...
    WSock1.LineMode:=true;
    end;
 ackTimer.Enabled:=false;

end;

procedure TviewForm.videoBoxClick(Sender: TObject);
begin
 if videoBox.Checked=true then blankString:='v=1'
 else blankString:='v=0';
end;

{ hack to deal with invocation of CheckBoxes' OnClick handler even when
  state is changed by software }
procedure SafeSetChecked(Chk: TCheckBox; val: boolean);
var SavedOnClick: TNotifyEvent;
begin
 SavedOnClick:=Chk.OnClick;
 Chk.OnClick:=nil;
 Chk.Checked:=val;
 Chk.OnClick:=SavedOnClick;
end;

procedure SafeResize(side: char; value: integer);
var SavedOnResize: TNotifyEvent;
begin
 SavedOnResize:=viewForm.OnResize;
 viewForm.OnResize:=nil;
 if side = 'x' then viewForm.Width:=value
 else begin
    if formshrinked then viewForm.Height:=value
    else viewForm.Height:=value+(Devices.vCount)*sensorHeight;
    end;
 viewForm.OnResize:=savedOnResize;
end;

procedure SafeSetPos(Dev: TPDeviceDef; p: integer);
begin
end;

procedure TviewForm.setImageSize;
begin
 if not menu_stretch.checked then begin
    Image1.Left:=4+ 160 - framexsize div 2;
    if Image1.Left < 4 then Image1.Left:=4;
    Image1.Top:=4+ 120 - frameysize div 2;
    if Image1.Top < 4 then Image1.Top:=4;

    if frameysize<=Panel1.Height-8 then
       Image1.Height:=frameysize
    else Image1.Height:=Panel1.Height-8;

    if framexsize<=Panel1.Width-8 then
       Image1.Width:=framexsize
    else Image1.Width:=Panel1.Width-8;

    Image1.Width:=framexsize;
    Image1.Stretch:=false
    end
 else begin
    Image1.Left:=4;
    Image1.Top:=4;
    Image1.Height:=Panel1.Height-8;
    Image1.Width:=Panel1.Width-8;
    Image1.Stretch:=true;
    end;
end;

procedure TviewForm.menu_stretchClick(Sender: TObject);
begin
 menu_stretch.Checked:=not menu_stretch.Checked;
 setImageSize;
end;

procedure TviewForm.FormResize(Sender: TObject);
var imgWidth, imgHeight: integer;
begin

 imgWidth:=(viewForm.Width-133) and $FFF8;
 safeResize('x',imgWidth+133);

 imgHeight:=(viewForm.Height-157) and $FFF8;
 safeResize('y',imgHeight+157);
 resizeAll(imgWidth,imgHeight);
 setImageSize;
end;

procedure TviewForm.resizeAll(imgWidth: integer; imgHeight: integer);
begin
 // warning - voodoo inside...
 panel1.Width:=imgWidth+8;
 panel1.Height:=imgHeight+8;
 panel2.Left:=imgWidth+38;
 panel2.Height:=imgHeight+8;
 bottomPanel.Top:=imgHeight+47;
 bottomPanel.Width:=imgWidth+105;
 xScrollBar.Top:=imgHeight+13;
 xScrollBar.Width:=imgWidth+8;
 xvalLabel.Top:=imgHeight+28;
 xvalLabel.Left:=imgWidth+17;
 yScrollBar.Left:=imgWidth+16;
 yScrollBar.Height:=imgHeight+8;
 yvalLabel.Top:=imgHeight+12;
 yvalLabel.Left:=imgWidth+35;
end;


procedure TviewForm.menu_msgClick(Sender: TObject);
begin
 menu_msg.Checked:=not menu_msg.Checked;
 if menu_msg.Checked then begin
    srvLabel.Caption:=TResourceLocalizer.GetString(LANG,115);
    cachedServer:=srvEdit.Text;
    srvEdit.Text:=cachedMessage;
    end
 else begin
    srvLabel.Caption:=TResourceLocalizer.GetString(LANG,116);
    cachedMessage:=srvEdit.text;
    srvEdit.Text:=cachedServer;
    end
end;

procedure TviewForm.SrvEditKeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then begin
    if menu_msg.Checked then sendmsg(srvEdit.Text)
    else if connStatus=CONN_UNCONNECTED then streamBtnClick(Self);
    Key:=#0;
    end
end;

procedure TviewForm.sendmsg(s: String);
begin
 if (connStatus=CONN_CURRENT) and (srvEdit.Text<>'') then
    srvEdit.Enabled:=false;
end;

procedure TviewForm.menu_frClick(Sender: TObject);
begin
 menu_fr.Checked:= not menu_fr.Checked;
end;

procedure TDevices.abortChange(Sender: TObject);
begin
 exit;
end;

procedure TDevices.controlChange(Sender: TObject);
var n,v: integer;
begin
 v:=0; // turn off 'uninitialized var' warning
 n:=(Sender as TWinControl).Tag;

 //lock
 Device^[n].Changed:=true;
 anyChanged:=true;
 //unlock

 if Device^[n].typ='t' then
    v:=(Device^[n].widgetset.wc as TTrackBar).Position+Device^[n].offsetPost
 else if Device^[n].typ='s' then begin
    v:=(Device^[n].widgetset.wc as TScrollBar).Position+Device^[n].offsetPost;
    // Position grows _downward_ for vertical TScrollBars... need to adjust
    if Device^[n].isYbar then v:=Device^[n].imin+Device^[n].imax-v;
    end;
 Device^[n].changedVal:=v;
 updateLabel(n,v);
 {$IFDEF DEBUG}
 debug('ChangedVal: device '+IntToStr(n)+' value: '+IntToStr(v));
 {$ENDIF}
end;


{ we want the scrollbar thumb to be always visible, but only draggable
  when we're in control, so discard all messages directed to scrollbars
  except repaints (15) }
procedure TviewForm.appMsgHandler(var Msg: TMsg; var handled: boolean);
begin
 if ((Msg.Hwnd=viewForm.xScrollBar.Handle) or
     (Msg.Hwnd=viewForm.yScrollBar.Handle) or
     (Msg.Hwnd=viewForm.zScrollBar.Handle)) and
     (Msg.Message<>15) and
     (ctlStatus<>CTL_CURRENT) then begin
     handled:=true;
     end;
 if assigned(AppOldMsgHandler) then AppOldMsgHandler(Msg, handled)
end;

procedure TViewForm.serverMenuClick(Sender: TObject);
begin
 if not menu_msg.Checked then
    ViewForm.srvEdit.Text:=servers[(Sender as TMenuItem).menuIndex].url
 else
    cachedServer:=servers[(Sender as TMenuItem).menuIndex].url;
 if connStatus=CONN_UNCONNECTED then Connect
 else if connStatus=CONN_CURRENT then begin
    Disconnect;
    Connect;
    end;
end;

procedure TviewForm.menu_lblClick(Sender: TObject);
begin
 menu_lbl.Checked := not menu_lbl.Checked;
 xvalLabel.visible := menu_lbl.Checked;
 yvalLabel.visible := menu_lbl.Checked;
 zvalLabel.visible := menu_lbl.Checked;
end;

procedure TviewForm.WaveOutCallback(var msg:TMessage);
begin
 ACMWaveOut1.WaveOutCallback(msg);
end;

procedure TViewForm.WaveInCallback(var msg:TMessage);
begin
 ACMWaveIn1.WaveInCallback(msg);
end;

initialization
end.
