
/*
   Copyright 2001-2005 David Santinoli
   Released under the GPL. See file COPYING for details.
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.StringTokenizer;
import java.net.URLDecoder;

public class deviceFrame extends JFrame {

 private int cnt=0, special=0, currDev=0;
 private int debug=0;
 private device devArray[];
 private String rcsid= new String("$Id: deviceFrame.java,v 1.3 2005/05/05 20:26:55 santinod Exp santinod $");

 private class widgetSet {
    private JComponent wc;
    private JLabel l1;
    private JLabel l2;
    private JLabel ln;
    private JLabel lval;
    }

 private class device {
    private String name;
    private char typ;
    private widgetSet widgetset;
    private boolean isSpecial=false;
    private int imin=0, imax=0;
    private String fmin="", fmax="";
    private float scale=0, offset=0;
    private int dir;
    private int lastSetVal, lastTxVal;
    private boolean isYBar=false;
    }


 public class slListener implements ChangeListener {
    private int id;
    public slListener(int i) { id=i; }
    public void stateChanged(ChangeEvent e) {
       if(((JSlider)e.getSource()).getValueIsAdjusting()) {
          devArray[id].lastSetVal=((JSlider)e.getSource()).getValue();
          }
       }
    }

 public class sbListener implements AdjustmentListener {
    private int id;
    public sbListener(int i) { id=i; }
    public void adjustmentValueChanged(AdjustmentEvent e) {
       if(e.getValueIsAdjusting()) {
          devArray[id].lastSetVal=e.getValue();
          }
       }
    }

 public void DeviceFrame() {
    currDev=0;
    }

 public Dimension getPreferredSize() {
    return new Dimension(420,20+30*(cnt-special));
    }

 public void initDevices(int d) {
    int i;
    cnt=d;
    devArray = new device[d];
    for(i=0;i<d;i++) {
       devArray[i]=new device();
       devArray[i].widgetset = new widgetSet();
       }

    currDev=0;
    special=0;
    }

 public void flushDevices() {
    int i;
    for(i=0;i<cnt;i++) { /* XXX */
       if(!devArray[i].isSpecial) {
          getContentPane().remove(devArray[i].widgetset.wc);
          getContentPane().remove(devArray[i].widgetset.l1);
          getContentPane().remove(devArray[i].widgetset.l2);
          getContentPane().remove(devArray[i].widgetset.ln);
          getContentPane().remove(devArray[i].widgetset.lval);
          devArray[i].widgetset.wc=null;
          devArray[i].widgetset.ln=null;
          }
       else devArray[i].widgetset.wc.setVisible(false);
       devArray[i].widgetset=null;
       devArray[i]=null;
       }
    if(cnt>0) devArray=null;
    cnt=0;
    }

 public void addDevice(String s, JScrollBar xsb, JScrollBar ysb, JScrollBar zsb) {
    String n = null, v = null, dName = null;
    char type='s';
    StringTokenizer nv, def = new StringTokenizer(s,"; ");

    // System.out.println("Device definition: "+s);
    while(def.hasMoreTokens()) {
       nv = new StringTokenizer(def.nextToken(),"=");
       n = nv.nextToken();
       v = nv.nextToken();
       try {
       if("name".equals(n)) dName = URLDecoder.decode(v,"UTF-8");
       else if("imax".equals(n)) devArray[currDev].imax = Integer.parseInt(v);
       else if("imin".equals(n)) devArray[currDev].imin = Integer.parseInt(v);
       else if("fmax".equals(n)) devArray[currDev].fmax = v;
       else if("fmin".equals(n)) devArray[currDev].fmin = v;
       else if("dir".equals(n))  devArray[currDev].dir = Integer.parseInt(v);
       else if("type".equals(n)) devArray[currDev].typ = v.charAt(0);
          } catch (Exception e) {
             e.printStackTrace();
             }
       } // while

    devArray[currDev].name = dName;

    if(devArray[currDev].typ=='t') devArray[currDev].typ='s';

    if(devArray[currDev].typ=='x' || devArray[currDev].typ=='y' || devArray[currDev].typ=='z') {
       special++;
       devArray[currDev].isSpecial=true;
       }

    try {
       devArray[currDev].scale=
         (Float.parseFloat(devArray[currDev].fmax)-Float.parseFloat(devArray[currDev].fmin))
          /(devArray[currDev].imax-devArray[currDev].imin);
       devArray[currDev].offset=Float.parseFloat(devArray[currDev].fmin)
          -devArray[currDev].scale*devArray[currDev].imin;
       } catch (Exception e) {
          devArray[currDev].scale=0;
       }

    if(devArray[currDev].isSpecial) {
       if(devArray[currDev].typ=='x') {
          devArray[currDev].widgetset.wc = xsb;
          }
       else if(devArray[currDev].typ=='y') {
          devArray[currDev].widgetset.wc = ysb;
          devArray[currDev].isYBar = true;
          }
       else if(devArray[currDev].typ=='z') {
          devArray[currDev].widgetset.wc = zsb;
          }
       devArray[currDev].widgetset.wc.setVisible(true);
       devArray[currDev].typ='s';
       }

    if(devArray[currDev].typ=='s' && !devArray[currDev].isSpecial) {
       devArray[currDev].widgetset.wc = new JSlider(
          devArray[currDev].imin,
          devArray[currDev].imax);
       if(Math.abs(devArray[currDev].imax-devArray[currDev].imin)<=20) {
          //((JSlider)devArray[currDev].widgetset.wc).setPaintTicks(true);
          ((JSlider)devArray[currDev].widgetset.wc).setMajorTickSpacing(1);
          ((JSlider)devArray[currDev].widgetset.wc).setSnapToTicks(true);
          }
       devArray[currDev].widgetset.wc.setMinimumSize(new Dimension(140,20));
       }

    else if(devArray[currDev].typ=='p') {
       devArray[currDev].widgetset.wc = new JProgressBar(
          JProgressBar.HORIZONTAL,
          devArray[currDev].imin,
          devArray[currDev].imax);
       ((JProgressBar)devArray[currDev].widgetset.wc).setStringPainted(true);
       devArray[currDev].widgetset.wc.setMinimumSize(new Dimension(140,20));
       }

    if(!devArray[currDev].isSpecial) {
       devArray[currDev].widgetset.ln = new JLabel(dName+":");
       devArray[currDev].widgetset.l1 = new JLabel(devArray[currDev].fmin);
       devArray[currDev].widgetset.l1.setHorizontalAlignment(JLabel.RIGHT);
       devArray[currDev].widgetset.l2 = new JLabel(devArray[currDev].fmax);
       devArray[currDev].widgetset.lval = new JLabel("");
       }

    if(devArray[currDev].isSpecial) {
       int m=(devArray[currDev].imax-devArray[currDev].imin)/10;
       if(m==0) m=1;
       ((JScrollBar)devArray[currDev].widgetset.wc).setValues(
          (devArray[currDev].imax+devArray[currDev].imin)/2,
          m,
          devArray[currDev].imin,
          devArray[currDev].imax+m
          );
        }

    if(devArray[currDev].typ=='s' && !devArray[currDev].isSpecial) {
/*
       ((JSlider)devArray[currDev].widgetset.wc).setMinimum(
          devArray[currDev].imin);
       ((JSlider)devArray[currDev].widgetset.wc).setMaximum(
          devArray[currDev].imax);
*/
       ((JSlider)devArray[currDev].widgetset.wc).setValue(
          (devArray[currDev].imax+devArray[currDev].imin)/2 );
       }

    if(devArray[currDev].typ=='s') {
       if(devArray[currDev].isSpecial)
          ((JScrollBar)devArray[currDev].widgetset.wc).addAdjustmentListener(new sbListener(currDev));
       else
          ((JSlider)devArray[currDev].widgetset.wc).addChangeListener(new slListener(currDev));
       }

    devArray[currDev].lastSetVal=
       (devArray[currDev].imax+devArray[currDev].imin)/2;

    System.out.println("Added device "+dName);

    if(++currDev==cnt) packDevices();
    }

 private void packDevices() {
    int i,j;
    GridBagLayout gbl=new GridBagLayout();
    getContentPane().setLayout(gbl);
    GridBagConstraints gbc=new GridBagConstraints();
    gbc.insets=new Insets(2,2,2,2);

    for(i=0,j=0;i<cnt;i++) {
       if(devArray[i].isSpecial) continue;

       gbc.weightx=0.8;
       gbc.fill=GridBagConstraints.HORIZONTAL;
       gbc.gridx=0; gbc.gridy=j;
       gbc.ipadx=5; gbc.ipady=5;
       gbl.setConstraints(devArray[i].widgetset.l1,gbc);
       getContentPane().add(devArray[i].widgetset.l1);

       gbc.weightx=1.0;
       gbc.gridx=1; gbc.gridy=j;
       gbc.ipadx=0; gbc.ipady=0;
       gbl.setConstraints(devArray[i].widgetset.wc,gbc);
       getContentPane().add(devArray[i].widgetset.wc);

       gbc.weightx=0.8;
       gbc.gridx=2; gbc.gridy=j;
       gbc.ipadx=5; gbc.ipady=5;
       gbl.setConstraints(devArray[i].widgetset.l2,gbc);
       getContentPane().add(devArray[i].widgetset.l2);

       gbc.gridx=3; gbc.gridy=j;
       gbl.setConstraints(devArray[i].widgetset.ln,gbc);
       getContentPane().add(devArray[i].widgetset.ln);

       gbc.gridx=4; gbc.gridy=j;
       gbl.setConstraints(devArray[i].widgetset.lval,gbc);
       getContentPane().add(devArray[i].widgetset.lval);

       j++;
       }

    pack();
    }

 private void addParam(StringBuffer s, String par) {
    if(s.length()>0) s.append("; ");
    s.append(par);
    }

 public StringBuffer setParams(StringBuffer s) {
    //StringBuffer p = new StringBuffer();
    int i, v=0, set;

    for(i=0;i<cnt;i++) {
       if(devArray[i].dir==0) continue;
       set=devArray[i].lastSetVal;
       if(set!=devArray[i].lastTxVal) {
          if(devArray[i].typ=='s') {
             if(devArray[i].isYBar)
                v=devArray[i].imin+devArray[i].imax-set;
             else
                v=set;
             }
          if((debug&1)!=0) System.out.println("Update to server: c"+i+"="+v+" ("+set+")");
          devArray[i].lastTxVal=set;
          addParam(s,new String("c"+i+"="+v));
          }
       }
    return s;
    }

 public void activateDevices() {
    int i;
    for(i=0;i<cnt;i++)
       if(devArray[i].typ=='s')
          devArray[i].widgetset.wc.setEnabled(true);
    }

 public void deactivateDevices() {
    int i;
    for(i=0;i<cnt;i++)
       if(devArray[i].typ=='s')
          devArray[i].widgetset.wc.setEnabled(false);
    }

 public boolean needDevBox() {
    return cnt!=special;
    }

 public void setDevice(String s, boolean init) {
    int pos,d,n;

    pos=s.indexOf('=');
    d=Integer.parseInt(s.substring(1,pos));
    n=Integer.parseInt(s.substring(pos+1));

    /* update label */
    if(!devArray[d].isSpecial) {
       devArray[d].widgetset.lval.setText( new String (String.valueOf(
          (devArray[d].scale*n + devArray[d].offset) ) )
          );
       }

    /* update device */
    setDeviceValue(d,n);

    if(init) devArray[d].lastSetVal=n;

    return;
    }


 private void setDeviceValue(int d, int n) {
    if(devArray[d].typ=='s') {
       if(devArray[d].isSpecial) {
          if(! ((JScrollBar)devArray[d].widgetset.wc).getValueIsAdjusting() ) {
             if(devArray[d].isYBar)
                n=devArray[d].imin+devArray[d].imax-n;
             ((JScrollBar)(devArray[d].widgetset.wc)).setValue(n);
             }
          }
       else {
          if(! ((JSlider)devArray[d].widgetset.wc).getValueIsAdjusting() )
             ((JSlider)(devArray[d].widgetset.wc)).setValue(n);
          }
       }
    else if(devArray[d].typ=='p') {
       ((JProgressBar)(devArray[d].widgetset.wc)).setValue(n);
       }
    if((debug&1)!=0) System.out.println("device updated: c"+d+"="+n);
    }
}
