/*
    Network-related stuff.

    Copyright 2004 by David Santinoli <david@santinoli.com>

    Translated to C++ by Daniele Lavatelli <ldaniele@interfree.it>
*/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NET_H

 #define NET_H

 #define BUFLEN 20480 //test
 #define MP_BOUNDARY "--mp-boundary"
 #define ERRBUFLEN 256

 #define ACK 1

 #if ACK
 #define HTTP_UA "pclient/ack "VERSION" (Linux/Qt)"
 #else
 #define HTTP_UA "pclient "VERSION" (Linux/Qt)"
 #endif

 struct JpegFrameType
 {
  unsigned long index;
  unsigned long length;
  unsigned char *jpeg_buffer;
  unsigned long jpeg_buffer_length;
 };

 class Connection
 {
  public:
  Connection();
  ~Connection();
  enum ConnectStatus {CONN_UNCONNECTED,CONN_CONNECTING,CONN_CURRENT};
  enum ErrType { LOG=1, ERR=2, NOSTRERR=4 };
  int            HttpRequest(const char * user_agent);
  int            Disconnect(void);
  int            Connect(const char *server, const char *port);
  int            ParseGlobalHeaders(void);
  int            Ack(char *s, int len);
  ConnectStatus  GetConnStatus() {return mConnStatus;}
  char*          GetLastError(void) {return mLastError;}
  int            snapshotOnly(void) {return snapshot;}
  int            GetImage(JpegFrameType*);
  void           Log(char *err, int use_errno);
  void           ResetErr(void);
  
  private:
   ConnectStatus  mConnStatus;
   int            mSock;
   char           mBuf[BUFLEN];
   char           mLastError[ERRBUFLEN];
   char*          greeting;
   int            snapshot;
   inline int     net_read_line(char *buf, int len);
 };

#endif
