
/*
    Text draw routines.

    Copyright 2000-2006 by David Santinoli <david@santinoli.com>
*/

#include <string.h>
#include <ctype.h>
#include <time.h>
#include "caption.h"

#define HSIZE 6
#define VSIZE 13

#define CAPT_BACKGROUND 1

#define CAPT_R 0
#define CAPT_G 0
#define CAPT_B 0

#define CAPT_BG_R 255
#define CAPT_BG_G 255
#define CAPT_BG_B 255

struct char_bits {
    char chr;
    char grid[VSIZE][HSIZE];
};

#include "font1.c"

static const char rcsid[]="$Id: caption.c,v 1.1 2007/05/18 23:10:42 santinod Exp $";

int draw_captions(unsigned char *image, int width, int height)
{
 int idx, pos, c, x, y, x0, y0, n;
 unsigned char *p;
 int codepoint;
 struct tm *tt;
 time_t now;

 now=time(0);
 tt=localtime(&now);

 for(c=0;c<captions;c++) {

 n=strftime(caption[c].cooked,CAPTION_SIZEOF_COOKED,caption[c].raw,tt);
 if(n==0) continue;

 x0=caption[c].x;
 y0=caption[c].y;

 if(x0<0) x0=width-(n*HSIZE-x0);
 if(y0<0) y0=height-(VSIZE-y0);

 if(x0<0) x0=0;
 if(y0<0) y0=0;
 if(y0+VSIZE>height) y0=height-VSIZE;

 pos=0;
 while(pos<n) {
    if(x0+(pos+1)*HSIZE>width) break;
    for(codepoint=-1,idx=0;idx<sizeof(char_table)/sizeof(struct char_bits);idx++) {
       codepoint=char_table[idx].chr;
       if(caption[c].cooked[pos]==codepoint) break;
       }
    for(x=0;x<HSIZE;x++) {
       for(y=0;y<VSIZE;y++) {
          p=image+3*(x+x0+pos*HSIZE+(y+y0)*width);
          if(codepoint!=-1 && char_table[idx].grid[y][x]) {
             *(p++)=CAPT_R;
             *(p++)=CAPT_G;
             *(p++)=CAPT_B;
             }
          else if(CAPT_BACKGROUND) {
             *(p++)=CAPT_BG_R;
             *(p++)=CAPT_BG_G;
             *(p++)=CAPT_BG_B;
             }
          }
       }
    pos++;
    }

 }
 return 0;
}

