
#ifndef X_VIDEO_H
#define X_VIDEO_H 1

/* This prevents the
      /usr/src/linux/include/linux/videodev2.h:378: field `timestamp'
       has incomplete type
 error */
#include <sys/types.h>

#include <linux/videodev.h>

struct capture_parms {
   int card;
   int fd;
   int chan;
   unsigned char *buffer;       /* data from read() or mmap() are first moved
                                   here */
   int bufsize;
   unsigned char *yuv2rgbbuf;   /* only allocated if conversion needed */
   struct video_mbuf v_mbuf;
   unsigned char *mbuffer;      /* buffer for mmap() */
   int capx;
   int capy;
   int mono;
   int palette;
   int depth;
   int quality;
   };

extern struct capture_parms cparms;

void video_init(char *devname, int chan, int mono);
void video_cleanup(void);
void video_alloc_buffers(void);
void video_free_buffers(void);
void video_capture_compress(int nojpeg);
void video_change_param(int par, int val);

#endif /* X_VIDEO_H */
