/* 

    Simple X11 capture monitor.

    Copyright 2007 by David Santinoli <david@santinoli.com>
*/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include <Imlib.h>
#include "video.h"

static const char rcsid[]="$Id: x11mon.c,v 1.2 2007/05/18 23:26:22 santinod Exp $";

static Display *disp;
static ImlibData *id;
static Window win;
static ImlibImage *im;


int x11_monitor_init(int capx, int capy)
{
 XSetWindowAttributes attr;

 disp=XOpenDisplay(NULL);
 id=Imlib_init(disp);
 win=XCreateWindow(disp,DefaultRootWindow(disp),0,0,
    capx,capy,0,id->x.depth,InputOutput,id->x.visual,0,&attr);
 XMapWindow(disp,win);
 XSync(disp,False);
 XStoreName(disp,win,"Eye of Palantir");

 return 0;
}

void x11_monitor(unsigned char *buf, int capx, int capy)
{
 im=Imlib_create_image_from_data(id,buf,NULL,capx,capy);
 Imlib_paste_image(id,im,win,0,0,im->rgb_width,im->rgb_height);
 Imlib_kill_image(id,im);
 XSync(disp,False);
}
